Package com.orchestranetworks.search.template

# Interface SearchTemplateManager

public interface SearchTemplateManager
Provides access to the declared search templates.

Since:
  6.0.0
See Also:
  - `SearchTemplate`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Collection<SearchTemplate>`
  `getBuiltInTemplates()`
  Returns the built-in search templates.
  `SearchTemplate`
  `getDefaultTemplate()`
  Returns a search template instance that can target every visible field, using its default search strategy.
  `static SearchTemplateManager`
  `getInstance()`
  `Collection<SearchTemplate>`
  `getModuleTemplates(com.onwbp.base.repository.Module aModule)`
  Returns the search templates registered in the given module.
  `SearchTemplate`
  `getTemplateOrNull(SearchTemplateKey aKey)`
  Returns the search template registered with the given key.
  `Collection<SearchTemplate>`
  `getTemplates()`
  Returns all registered search templates.

- ## Method Details

  - ### getInstance

    static SearchTemplateManager getInstance()

  - ### getDefaultTemplate

    SearchTemplate getDefaultTemplate()
    Returns a search template instance that can target every visible field, using its default search strategy.

  - ### getTemplates

    Collection<SearchTemplate> getTemplates()
    Returns all registered search templates.

  - ### getTemplateOrNull

    SearchTemplate getTemplateOrNull(SearchTemplateKey aKey)
    Returns the search template registered with the given key. When no registered template is found, then it returns null.
    Throws:
      `IllegalArgumentException` - If
      - The specified search template key does not belong to any module.

  - ### getBuiltInTemplates

    Collection<SearchTemplate> getBuiltInTemplates()
    Returns the built-in search templates.

  - ### getModuleTemplates

    Collection<SearchTemplate> getModuleTemplates(com.onwbp.base.repository.Module aModule)
    Returns the search templates registered in the given module.
    Throws:
      `IllegalArgumentException` - If
      - The specified module is `null`.